function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useEffect, useState } from 'react';
import useNode from '../useNode';
import '../../styles/column2row.less';
import { Spin, Input, Form } from 'antd';
import Config from './config';
import Preview from './preview';
import _ from 'lodash';
export var classPrefix = 'flow-column2row-config';
var FlowColumn2RowConfig = function FlowColumn2RowConfig(_ref) {
  var node = _ref.node;
  var _useNode = useNode(node),
    columnList = _useNode.columnList,
    loading = _useNode.loading;
  var _useState = useState(node.getData().label),
    _useState2 = _slicedToArray(_useState, 2),
    actName = _useState2[0],
    setActName = _useState2[1];
  var _useState3 = useState([]),
    _useState4 = _slicedToArray(_useState3, 2),
    targetColumns = _useState4[0],
    setTargetColumns = _useState4[1];
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    columnName = _useState6[0],
    setColumnName = _useState6[1];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    columnValue = _useState8[0],
    setColumnValue = _useState8[1];
  useEffect(function () {
    var nodeData = node.getData();
    if (nodeData.targetColumns) setTargetColumns(nodeData.targetColumns);
    if (nodeData.columnName) setColumnName(nodeData.columnName);
    if (nodeData.columnValue) setColumnValue(nodeData.columnValue);
  }, []);
  useEffect(function () {
    var nameList = targetColumns.map(function (item) {
      return item.name;
    });
    var res = columnList.filter(function (item) {
      return !nameList.includes(item.name);
    });
    node.updateData({
      status: targetColumns.length && columnName && columnValue && actName ? 'success' : 'failed',
      targetColumns: targetColumns,
      columnName: columnName,
      columnValue: columnValue,
      columnList: res,
      label: actName
    });
  }, [targetColumns, columnName, columnValue, actName]);
  if (loading) {
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix
    }, /*#__PURE__*/React.createElement(Spin, {
      className: "".concat(classPrefix, "-loading")
    }));
  }
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix
  }, /*#__PURE__*/React.createElement(Form, null, /*#__PURE__*/React.createElement(Form.Item, {
    label: "\u52A8\u4F5C\u540D\u79F0",
    colon: false,
    className: "action-name-box ".concat(actName === '' && 'error')
  }, /*#__PURE__*/React.createElement(Input, {
    value: actName,
    maxLength: 50,
    showCount: true,
    onChange: function onChange(e) {
      return setActName(_.trim(e.currentTarget.value));
    }
  }), actName === '' && /*#__PURE__*/React.createElement("div", {
    className: "action-name-box-error"
  }, "\u8BF7\u8F93\u5165\u52A8\u4F5C\u540D\u79F0"))), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-box")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-left")
  }, /*#__PURE__*/React.createElement(Config, {
    columnList: columnList,
    defaultValue: targetColumns,
    onChange: setTargetColumns
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-right")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-title")
  }, /*#__PURE__*/React.createElement("span", {
    className: "title"
  }, "\u7ED3\u679C\u9884\u89C8")), /*#__PURE__*/React.createElement("div", {
    className: "".concat(classPrefix, "-to-preview")
  }, /*#__PURE__*/React.createElement(Preview, {
    defaultValue: {
      columnName: columnName,
      columnValue: columnValue
    },
    list: columnList,
    selected: targetColumns,
    onChange: function onChange(val) {
      setColumnName(val === null || val === void 0 ? void 0 : val.columnName);
      setColumnValue(val === null || val === void 0 ? void 0 : val.columnValue);
    }
  })))));
};
export default FlowColumn2RowConfig;